<?php 
if(!defined('ABSPATH'))
	die();


class wpq_BulletinWriteController extends IvyController
{
	private $contribute_form = array();
	private $allowed_meta = array();
	
	public function __construct()
	{
		parent::__construct();
		
		/*if ( ! is_user_logged_in() ) {
			wp_redirect( IvyController::get_permalink( 'login' ) );
			exit;
		}
		
		if(!current_user_can('edit_bulletins'))
			wp_die('U heeft niet genoeg rechten om deze pagina te bekijken.');*/
			
		$this->allowed_meta = array(
			'ecpt_overview',
			'ecpt_graduate',
			'ecpt_internship',
			'ecpt_conclusion',
			'ecpt_careershomepage',
			'ecpt_logo'
		);
		
		$this->contribute_form = array(
			'title' => array(
				'title' => 'Title',
				'rules' => 'required'
			),
			'category' => array(
				'title' => 'Sector',
				'type' => 'select',
				'options' => $this->get_cat_options()
			),
			'meta_ecpt_overview' => array(
				'title' => 'Overview',
				'type' => 'textarea',
				'rules' => array('required')
			),
			'meta_ecpt_graduate' => array(
				'title' => 'Graduate',
				'type' => 'textarea',
				'rules' => array('required')
			),
			'meta_ecpt_internship' => array(
				'title' => 'Internship',
				'type' => 'textarea',
				'rules' => array('required')
			),
			'meta_ecpt_conclusion' => array(
				'title' => 'Conclusion',
				'type' => 'textarea',
				'rules' => array('required')
			),
			'meta_ecpt_careershomepage' => array(
				'title' => 'Careers homepage',
				'rules' => array('required')
			),
			'meta_ecpt_logo' => array(
				'title' => 'Logo'
			)
		);
	}

	
	private function get_cat_options()
	{
		$terms = get_terms('sectors',
			array(
				'get' => 'all'
			)
		);
		
		$options = array(0 => 'Select a sector...');
		
		foreach($terms as $term)
		{
			$options[$term->term_id] = $term->name;
		}
		
		return $options;
	}
	
	
	public function index()
	{
		$notices = array();
		
		IvyCore::load_core_library('form');
				
		$form = new IvyForm($this->contribute_form);		
		
		if(isset($_POST['action']) && $_POST['action'] == 'bulletin-write' && $form->validate())
		{
			if(!wp_verify_nonce($_POST['_leezernonce'], 'bulletin-write'))
			{
				wp_die(__('Cheatin&#8217; uh?'));
			} else
			{
				//if(!current_user_can('edit_bulletins'))
				//	wp_die('U kunt helaas geen berichten aanmaken.');

				// Create post
				
				$post = array(
					'post_status'  => 'publish',
					'post_type'    => 'companies',
					'post_title'   => $_POST['title'],
					'post_content' => ''
				);

				$post_id = wp_insert_post($post);
			
				
				// Check if succesful

				if(!is_wp_error($post_id))
				{
					// Set category
					
					if($cat = $form->value('category'))
					{
						wp_set_object_terms($post_id, (int)$cat, 'sectors');
					}
					
					// Set meta fields
					
					foreach($_POST as $key => $value)
					{
						if(substr($key, 0, 5) == 'meta_' && in_array(substr($key, 5), $this->allowed_meta))
						{
							update_post_meta($post_id, substr($key, 5), $value);
						}
					}
				
					// Redirect
					
					$post_status = 'publish';
					IvyView::load('bulletin-write-success', compact('notices', 'post_status', 'post_id', 'date'));
					
					return;
				} else
				{
					wp_die('The message could not be published.', get_option('admin_email'));
				}
			}
		}
		
		IvyView::load('bulletin-write', array(
				'form' => $form,
				'notices' => $notices,
				'form_fields' => $this->contribute_form
			)
		);
	}
}