<?php 
if ( ! defined( 'ABSPATH' ) )
	die( "Can't load this file directly" );

class IvySetting
{
	private function __construct() {}
	
	private static $identifier = '';
	
	public static function add( $name, $default_value, $autoload = 'yes' ) {
		$option_name = self::$identifier . '_' . $name;
		add_option( $option_name, $default_value );
	}
	
	public static function set_identifier( $identifier ) {
		self::$identifier = $identifier;
	}
	
	public static function get( $setting ) {
		$option_name = self::$identifier . '_' . $setting;
		return get_option( $option_name );
	}
	
	public static function register( $group, $name ) {
		register_setting( $group, self::$identifier . '_' . $name );
	}
	
	public static function set( $setting, $value ) {
		$option_name = self::$identifier . '_' . $setting;
		return update_option( $option_name, $value );
	}
}