<?php

/* Plugin name: WPQ Post form
 */

if(!defined('ABSPATH'))
	die();


require_once('ivyCore/ivyCore.php');
require_once('helper.php');



class WPQPostForm extends IvyCore
{
	protected $post_types = array();
	
	protected $taxonomies = array();
	
	protected $post_types_caps = array();

	// Register controllers
	
	protected $shortcode_controllers = array(
		'bulletin-write'
	);


	// ---- Public functions ----
	
	
	public function __construct()
	{
		parent::__construct(__FILE__, 'wpq');

		// Register post types (actually, the real registering is done in ivyCore)
		
		/*$this->post_types = array(
			'companies' => array(
				'labels' => array(
					'name' => 'Companies',
					'singular_name' => 'Company'
				),
				'public' => true,
				'menu_position' => 5,
				'supports' => array('title', 'editor', 'comments', 'custom-fields'),
				'has_archive' => 'companies',
				'rewrite' => array(
					'slug' => 'company'
				)
			)
		);
		
		
		// Register taxonomies
		
		$this->taxonomies = array(
			'companies' => array(
				'sectors' => array(
					'labels' => array(
						'name' => 'Sectors',
						'singular_name' => 'Sector'
					),
					'hierarchical' => true
				)
			)
		);*/
		
		
		// Register settings

		self::$settings = array(
			'activated'				=> 'no',
			'default_pages_created' => 'no'
		);
		
		// Register actions and filters
		
		add_action('init', array($this, 'action_activate'));
		
		if(is_admin())
		{
			add_action('admin_init', array($this, 'action_register_settings'));
		}
	}


	public function action_activate()
	{
		global $wpdb;
	
		$activated = IvySetting::get('activated');
		
		if($activated == 'yes')
			return;
		
		parent::action_activate();

		// Create default pages
		
		$default_pages_created = IvySetting::get('default_pages_created');
		
		if(empty($default_pages_created) || $default_pages_created == 'no')
		{
			$this->create_default_pages();	
			IvySetting::set('default_pages_created', 'yes');
		}
	}
	
		
	public function action_register_settings() 
	{
		foreach(self::$settings as $name => $default_value) {
			IvySetting::register('community-links-settings', $name);
		}
	}

	
	// ---- Private functions ----
	
	
	private function create_default_pages() 
	{
		$identifier = self::get_identifier();
		
		$pages = array(
			array(
				'post_title' => 'Add company profile',
				'post_content' => "[{$identifier}-bulletin-write]"
			)
		);
			
		$default = array(
			'post_status'    => 'publish',
			'post_type'      => 'page',
			'comment_status' => 'closed',
			'ping_status'    => 'closed',
			);
			
		foreach($pages as $page)
		{
			$page = array_merge($page, $default);
			wp_insert_post($page);
		}
		
		IvySetting::set('default_pages_created', 'yes');
	}
}

global $wpq_postform;
$wpq_postform = new WPQPostForm();
